bool Toaster::process() {
  if (evQueueIsEmpty()) {
    return false;
  }
  Event e = evQueue[evQueueHead];
  evQueueHead = (evQueueHead + 1) & (evQueueSize - 1);

  for ( uint8_t i=0; i<sizeof(fsmApp)/sizeof(Transition); i++ ) {
    if (   ( (currentState == fsmApp[i].currentState) && (e == fsmApp[i].event) )
        || (fsmApp[i].event == 0)   )
    {
      if (e == Tick) {
        // System Tick
        fsmApp[i].currentState->tickAcktion();

        timeInState++;
        if (   (fsmApp[i].maxTimeBeforeTransition != 0)
            && (timeInState < fsmApp[i].maxTimeBeforeTransition) )
        {
          // Normal Tick
          fsmApp[i].currentState->tickAcktion();
        } else {
          // Force Transition because of an Timeout
          fsmApp[i].currentState->exitAction();
          currentState = fsmApp[i].nextState;
          currentState->entryAction();
          timeInState = 0;
        }
      } else {
        timeInState = 0;
        fsmApp[i].currentState->exitAction();
        currentState = fsmApp[i].nextState;
        currentState->entryAction();
      }
      break;
    }
  }
  return true;
}